{-Test prog for crcmodel, we Jul.2008}

program t_cmodel;

{$i STD.INC}

{$ifdef APPCONS}
  {$apptype console}
{$endif}

uses
  {$ifdef USEDLL}
    {$ifdef VirtualPascal}
      ch_intv,
    {$else}
      ch_intf,
    {$endif}
  {$else}
    crcmodel,
  {$endif}
  {$ifdef WINCRT}
    WinCRT,
  {$endif}
  BTypes, crcm_cat;

var
  CTab: TCRC32Tab;

var
  ctx: TCRC_ctx;
  buf: array[0..$1000-1] of byte;

procedure Test(Para: TCRCParam);
var
  CRCF, CRCT: longint;
  Err: word;
const
  cs: array[0..8] of char8 = '123456789';
begin
  cm_Create(Para,nil,ctx);
  cm_File('digs',ctx,CRCF,buf,sizeof(buf),Err);
  write(Para.name:19, cm_SelfTest(Para):10);
  write((Err=0) and (ctx.check=CRCF):10);
  if ctx.width>7 then begin
    cm_CalcTab(Para, CTab);
    cm_Create(Para,@CTab,ctx);
    cm_Full(ctx,CRCT,@cs,9);
    writeln(ctx.check=CRCT:10);
  end
  else writeln('---':10);
end;



begin
  {$ifdef USEDLL}
    writeln('CH_DLL Version ',CH_DLL_Version);
  {$endif}

  {Selftest, File no table, String with table}

  writeln('CRC name':19,'Selftest':10, 'File/NT':10, 'Str/Tab':10);
  writeln('-------------------------------------------------');

  Test(CRC5_USB);
  Test(CRC16_X25);
  Test(CRC8);
  Test(CRC8_DALLAS1W);
  Test(CRC8_ICODE);
  Test(CRC11);
  Test(CRC15);
  Test(CRC16_ATOM);
  Test(CRC16_AUG2_CITT);
  Test(CRC16_AUG_CITT);
  Test(CRC16_BT_CHIP);
  Test(CRC16_BUYPASS);
  Test(CRC16_CITT);
  Test(CRC16_DNP);
  Test(CRC16_ICODE);
  Test(CRC16_MCRF4XX);
  Test(CRC16_MCRF4XX);
  Test(CRC16_USB);
  Test(CRC16_KERMIT);
  Test(CRC16_MODBUS);
  Test(CRC16_R);
  Test(CRC16_XKERMIT);
  Test(CRC16_ZMODEM);
  Test(CRC24_PGP);
  Test(CRC24_FLEXRAYA);
  Test(CRC24_FLEXRAYB);
  Test(CRC32_Zip);
  Test(CRC32_C);
  Test(CRC32_POSIX);
  Test(CRC32_JAMCRC);
  Test(CRC32_XFER);

end.
